Bug 651074 - Move mpi module files and add conflict line.
Summary: Move mpi module files and add conflict line.
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: openmpi
Version: rawhide
Hardware: Unspecified
OS: Linux
low
medium
Target Milestone: ---
Assignee: Jay Fenlason
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-11-08 19:08 UTC by Erik Zeek
Modified: 2014-08-31 23:30 UTC (History)
6 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2012-02-01 19:28:34 UTC


Attachments (Terms of Use)

Description Erik Zeek 2010-11-08 19:08:41 UTC
Currently the Mpich2 and OpenMPI modules can be loaded simultaneously.  This causes problems when configuring (wrong packages are found).  It also exacerbates bug #647147.

Please move the module files to subdirectories ("mpi") of /usr/share/Modules/modulefiles and/or /etc/modulefiles and add a line, "conflict mpi." to both.  In addition to only allowing one MPI compiler to be loaded at a time, this allows "module load mpi" and "module switch mpi mpi/bob" to work as expected.

Comment 1 Bug Zapper 2011-05-30 14:00:33 UTC
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 2 Susi Lehtola 2011-09-22 22:24:51 UTC
(In reply to comment #0)
> Please move the module files to subdirectories ("mpi") of
> /usr/share/Modules/modulefiles and/or /etc/modulefiles and add a line,
> "conflict mpi." to both.  In addition to only allowing one MPI compiler to be
> loaded at a time, this allows "module load mpi" and "module switch mpi mpi/bob"
> to work as expected.

So "conflict mpi." wouldn't self-conflict?
Which module would "module load mpi" pick?

If you would like to have this implemented, then it would be best to file a proposal about appending the MPI packaging guidelines to the Fedora Packaging Committee.

Comment 3 Orion Poplawski 2011-11-17 22:58:53 UTC
[orion@orca ~]$ module avail

-------------------------------- /usr/share/Modules/modulefiles ---------------------------------
dot         module-cvs  module-info modules     null        use.own

--------------------------------------- /etc/modulefiles ----------------------------------------
mpi/mpich2-i386  mpi/openmpi-i386
[orion@orca ~]$ module load mpi
[orion@orca ~]$ module list
Currently Loaded Modulefiles:
  1) mpi/openmpi-i386
[orion@orca ~]$ module load mpich2-i386
ModuleCmd_Load.c(204):ERROR:105: Unable to locate a modulefile for 'mpich2-i386'
[orion@orca ~]$ module load mpi/mpich2-i386
mpi/mpich2-i386(7):ERROR:150: Module 'mpi/mpich2-i386' conflicts with the currently loaded module(s) 'mpi/openmpi-i386'
mpi/mpich2-i386(7):ERROR:102: Tcl command execution failed: conflict mpi

Not really sure why in loaded mpi/openmpi-i386 over mpi/mpich2-i386, but whatever.

This would require some coordination since it changes the names of the modules, but it seems reasonable to me.  Erik - are you up for filing a proposal?

Comment 4 Susi Lehtola 2011-11-17 23:06:10 UTC
Yes, this looks reasonable and we probably should do this one way or another.

Adding conflicts would maybe be a path of lesser resistance...?

Comment 5 Susi Lehtola 2011-12-16 09:50:37 UTC
ping?

Comment 6 Doug Ledford 2012-01-20 16:23:15 UTC
(In reply to comment #2)
> (In reply to comment #0)
> > Please move the module files to subdirectories ("mpi") of
> > /usr/share/Modules/modulefiles and/or /etc/modulefiles and add a line,
> > "conflict mpi." to both.  In addition to only allowing one MPI compiler to be
> > loaded at a time, this allows "module load mpi" and "module switch mpi mpi/bob"
> > to work as expected.
> 
> So "conflict mpi." wouldn't self-conflict?

No, in this instance the conclict mpi is referring to a trait of the modules system where if you have a directory of module files and you use the conflict <directory> directive, then it will conflict if any *other* file from that directory is loaded.

> Which module would "module load mpi" pick?

This, I assume, is probably directory order based.  Whichever file it finds first in the directory listing it uses.  In order to pick a specific one, you need to specify it specifically.

> If you would like to have this implemented, then it would be best to file a
> proposal about appending the MPI packaging guidelines to the Fedora Packaging
> Committee.

I agree, the guidelines should be updated.  I am, however, implementing this in f15/f16/rawhide in a back compatible way.  I'll preserve the existing module file as is, but I'm adding the mpi directory and the new module file in that directory along side the new one.  That way old installations will continue to work for now, but the new functionality will also be present as other mpis are updated to match.

Comment 7 Fedora Update System 2012-01-20 19:19:36 UTC
openmpi-1.5.4-3.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/openmpi-1.5.4-3.fc16

Comment 8 Fedora Update System 2012-01-20 19:20:06 UTC
openmpi-1.5.4-3.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/openmpi-1.5.4-3.fc15

Comment 9 Fedora Update System 2012-01-21 21:50:05 UTC
Package openmpi-1.5.4-3.fc15:
* should fix your issue,
* was pushed to the Fedora 15 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing openmpi-1.5.4-3.fc15'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-0725/openmpi-1.5.4-3.fc15
then log in and leave karma (feedback).

Comment 10 Fedora Update System 2012-02-01 19:28:34 UTC
openmpi-1.5.4-3.fc16 has been pushed to the Fedora 16 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 11 Fedora Update System 2012-02-01 19:29:45 UTC
openmpi-1.5.4-3.fc15 has been pushed to the Fedora 15 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.